/****************************************************************************
 *	Copylight(C) 2011 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	Form1.cs
 *
 *	@brief	VA|[gʐMvO.
 *
 *	@author	V 閾
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace sample_0007
{
	public partial class Form1 : Form
	{
		/****************************************************************************/
		/*!
		 *	@brief	{[[gi[p̃NX`.
		 */
		private class BuadRateItem : Object
		{
			private string	m_name  = "";
			private int		m_value = 0;

			// \
			public string NAME
			{
				set { m_name = value; }
				get { return m_name;  }
			}

			// {[[gݒl.
			public int BAUDRATE
			{
				set { m_value = value; }
				get { return m_value;  }
			}

			// R{{bNX\p̕擾֐.
			public override string  ToString()
			{
				return m_name;
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	vgRi[p̃NX`.
		 */
		private class HandShakeItem : Object
		{
			private string		m_name  = "";
			private Handshake	m_value = Handshake.None;

			// \
			public string NAME
			{
				set { m_name = value; }
				get { return m_name;  }
			}

			// vgRݒl.
			public Handshake HANDSHAKE
			{
				set { m_value = value; }
				get { return m_value;  }
			}

			// R{{bNX\p̕擾֐.
			public override string  ToString()
			{
				return m_name;
			}
		}

		private delegate void Delegate_RcvDataToTextBox( string data );

		/****************************************************************************/
		/*!
		 *	@brief	RXgN^.
		 *
		 *	@param	Ȃ.
		 *
		 *	@retval	Ȃ.
		 */
		public Form1()
		{
			InitializeComponent();
		}

		/****************************************************************************/
		/*!
		 *	@brief	_CAȌ.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Form1_Load(object sender, EventArgs e)
		{
			//! p\ȃVA|[g̔z擾.
			string[] PortList = SerialPort.GetPortNames();

			cmbPortName.Items.Clear();

			//! VA|[gR{{bNXɃZbg.
			foreach( string PortName in PortList ){
				cmbPortName.Items.Add( PortName );
			}
			if( cmbPortName.Items.Count > 0 ){
				cmbPortName.SelectedIndex = 0;
			}

			cmbBaudRate.Items.Clear();

			// {[[gIR{{bNXɑIڂZbg.
			BuadRateItem baud;
			baud          = new BuadRateItem();
			baud.NAME     = "4800bps";
			baud.BAUDRATE = 4800;
			cmbBaudRate.Items.Add( baud );

			baud          = new BuadRateItem();
			baud.NAME     = "9600bps";
			baud.BAUDRATE = 9600;
			cmbBaudRate.Items.Add( baud );

			baud          = new BuadRateItem();
			baud.NAME     = "19200bps";
			baud.BAUDRATE = 19200;
			cmbBaudRate.Items.Add( baud );

			baud          = new BuadRateItem();
			baud.NAME     = "115200bps";
			baud.BAUDRATE = 115200;
			cmbBaudRate.Items.Add( baud );
			cmbBaudRate.SelectedIndex = 1;

			cmbHandShake.Items.Clear();

			// t[IR{{bNXɑIڂZbg.
			HandShakeItem ctrl;
			ctrl           = new HandShakeItem();
			ctrl.NAME      = "Ȃ";
			ctrl.HANDSHAKE = Handshake.None;
			cmbHandShake.Items.Add( ctrl );

			ctrl           = new HandShakeItem();
			ctrl.NAME      = "XON/XOFF";
			ctrl.HANDSHAKE = Handshake.XOnXOff;
			cmbHandShake.Items.Add( ctrl );

			ctrl           = new HandShakeItem();
			ctrl.NAME      = "RTS/CTS";
			ctrl.HANDSHAKE = Handshake.RequestToSend;
			cmbHandShake.Items.Add( ctrl );

			ctrl           = new HandShakeItem();
			ctrl.NAME      = "XON/XOFF + RTS/CTS";
			ctrl.HANDSHAKE = Handshake.RequestToSendXOnXOff;
			cmbHandShake.Items.Add( ctrl );
			cmbHandShake.SelectedIndex = 0;

			// Mp̃eLXg{bNXNA.
			sndTextBox.Clear();
			rcvTextBox.Clear();
		}

		/****************************************************************************/
		/*!
		 *	@brief	_CAȌI.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void Form1_FormClosed(object sender, FormClosedEventArgs e)
		{
			//! VA|[gI[vĂꍇAN[Y.
			if( serialPort1.IsOpen ){
				serialPort1.Close();
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	[I]{^Ƃ̏.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void exitButton_Click(object sender, EventArgs e)
		{
			//! _CAON[Y.
			Close();
		}

		/****************************************************************************/
		/*!
		 *	@brief	[ڑ]/[ؒf]{^ƂɃVA|[g̃I[v/N[Ys.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void connectButton_Click(object sender, EventArgs e)
		{

			if( serialPort1.IsOpen == true ){
				//! VA|[gN[Y.
				serialPort1.Close();

				//! {^̕\[ؒf][ڑ]ɕς.
				connectButton.Text = "ڑ";
			}else{
				//! I[vVA|[gR{{bNXo.
				serialPort1.PortName = cmbPortName.SelectedItem.ToString();

				//! {[[gR{{bNXo.
				BuadRateItem baud    = (BuadRateItem)cmbBaudRate.SelectedItem;
				serialPort1.BaudRate = baud.BAUDRATE;

				//! f[^rbgZbg. (f[^rbg = 8rbg)
				serialPort1.DataBits = 8;

				//! peBrbgZbg. (peBrbg = Ȃ)
				serialPort1.Parity = Parity.None;

				//! XgbvrbgZbg. (Xgbvrbg = 1rbg)
				serialPort1.StopBits = StopBits.One;

				//! t[R{{bNXo.
				HandShakeItem ctrl    = (HandShakeItem)cmbHandShake.SelectedItem;
				serialPort1.Handshake = ctrl.HANDSHAKE;

				//! R[hZbg.
				serialPort1.Encoding = Encoding.Unicode;

				try {
					//! VA|[gI[v.
					serialPort1.Open();

					//! {^̕\[ڑ][ؒf]ɕς.
					connectButton.Text = "ؒf";
				}
				catch ( Exception ex ){
					MessageBox.Show(ex.Message);
				}
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	[M]{^āAf[^Ms.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void sndButton_Click(object sender, EventArgs e)
		{
			//! VA|[gI[vĂȂꍇAsȂ.
			if( serialPort1.IsOpen == false ){
				return;
			}
			//! eLXg{bNXAMeLXgo.
			String data = sndTextBox.Text;

			//! MeLXgȂꍇAf[^M͍sȂ.
			if( string.IsNullOrEmpty( data ) == true ){
				return;
			}

			try {
				//! VA|[geLXg𑗐M.
				serialPort1.Write( data );

				//! Mf[^͂eLXg{bNXNA.
				sndTextBox.Clear();
			}
			catch ( Exception ex ){
				MessageBox.Show( ex.Message );
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	f[^MƂ̃Cxg.
		 *
		 *	@param	[in]	sender	Cxg̑M̃IuWFNg.
		 *	@param	[in]	e		Cxg.
		 *
		 *	@retval	Ȃ.
		 */
		private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
		{
			//! VA|[gI[vĂȂꍇAsȂ.
			if( serialPort1.IsOpen == false ){
				return;
			}

			try {
				//! Mf[^ǂݍ.
				string data = serialPort1.ReadExisting();

				//! Mf[^eLXg{bNXɏ.
				Invoke( new Delegate_RcvDataToTextBox( RcvDataToTextBox ), new Object[] {data} );
			}
			catch ( Exception ex ){
				MessageBox.Show( ex.Message );
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	Mf[^eLXg{bNXɏ.
		 *
		 *	@param	[in]	data	M.
		 *
		 *	@retval	Ȃ.
		 */
		private void RcvDataToTextBox( string data )
		{
			//! Mf[^eLXg{bNX̍ŌɒǋL.
			if( data != null ){
				rcvTextBox.AppendText( data );
			}
		}
	}
}

/* End of file */
